module Toolchain::Attributes::Configuration
  extend self

  # @param type [Symbol] :symbol or :string.
  #
  def hash_transformation=(type)
    if [:symbolize_keys, :stringify_keys].include?(type)
      @hash_transformation = type
    else
      raise Toolchain::Attributes::Errors::InvalidHashTransformation,
        "valid types: :symbolize_keys, :stringify_keys."
    end
  end

  # @return [Symbol] :symbolize_keys or :stringify_keys.
  #
  def hash_transformation
    @hash_transformation ||= :symbolize_keys
  end

  # Determines whether or not to include nil values
  # in the object.attributes Hash.
  #
  # @param value [Boolean]
  #
  def include_nil_in_attributes=(value)
    @include_nil_in_attributes = value
  end

  # @return [Boolean]
  #
  def include_nil_in_attributes
    @include_nil_in_attributes ||= false
  end

  # @yield Toolchain::Attributes::Configuration
  #
  def configure
    yield self
  end
end
