module Toolchain::Validations::Delegation
  module InstanceMethods

    # @return [Object]
    #
    attr_reader :delegator

    # @param delegator [Object]
    #
    def initialize(delegator)
      @delegator = delegator
    end
  end

  # @param base [Class]
  #
  def self.included(base)
    base.send(:include, InstanceMethods)
    base.class_eval do

      alias_method :_valid?, :valid?

      # @return [Boolean]
      #
      def valid?
        self.attributes = delegator.attributes
        _valid?.tap { delegator.errors = errors }
      end
    end
  end
end
