module Toolchain::Validations::Validators

  # Validates the acceptance of an attribute.
  # Accepted values are as follows: `true`, `1` and `"1"`.
  #
  # @example
  #   class User::Creator
  #     validates :terms, acceptance: {
  #       message: "the terms of service must be accepted"
  #     }
  #   end
  #
  class Acceptance < Base

    def validate
      errors.add(key_path, message || "must be accepted") if not_accepted?
    end

    private

    def not_accepted?
      ![1, "1", true].include?(value)
    end
  end
end
